/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package project82usb;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.Comparator;
import java.util.concurrent.TimeUnit;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author Илья
 */
public class neededUsbDeviceList {
    
    private  ArrayList<usbDevice> blackList;
    private  ArrayList<usbDevice> trueList;
    
    public neededUsbDeviceList(){
        this.blackList = new ArrayList<>();
        this.trueList = new ArrayList<>();
    }
    public ArrayList<usbDevice> getInitList(){
        return this.blackList;
    }
    public ArrayList<usbDevice> getWhiteList(){
        return this.trueList;
    }
    public void initialization() throws Exception{
        usbDeviceList blackDeviceList = new usbDeviceList();
        blackDeviceList.getUsbDeviceList();
        this.blackList = blackDeviceList.devList;
    }
    public void getTrueDeviceList() throws InterruptedException {
        usbDeviceList dl2 = new usbDeviceList();
        //костыль, возможна перепись совсем - нужно определиться с существованием объекта вне системы
        this.trueList.clear();
        dl2.getUsbDeviceList();
        boolean isinAnotherArrayList;
        for (usbDevice ud2:dl2.devList){ // "вычитаем" из множества dl2 множество dl1 (вычитаем blacklist, чтобы получить true usb девайсы) 
            isinAnotherArrayList = false;
            outer: for (usbDevice ud1:this.blackList){
                if (ud1.equals(ud2)){
                    isinAnotherArrayList = true;
                    break outer;
                }
            }
            if (!isinAnotherArrayList){
                this.trueList.add(ud2);
            }
        }
        this.sortDeviceList();
    }
    private void sortDeviceList(){
        usbDevice[] trueListArr = (usbDevice[]) this.trueList.toArray();
        Arrays.sort(trueListArr, (usbDevice devOne, usbDevice devTwo) -> Short.compare(devOne.getPort(), devTwo.getPort()));
        this.trueList = new ArrayList<usbDevice>(Arrays.asList(trueListArr));
    }
    public void printTrueDeviceList(){
        for (usbDevice ud:this.trueList){
            System.out.println("id продукта: " + ud.getIdProduct());
            System.out.println("id вендора: " + ud.getIdVendor());
            System.out.println("номер порта: " + ud.getPort());
            System.out.println();
        }
        System.out.println("Кол-во устройств: " + this.trueList.size());
    }
    
    public void printDeviceList(devicesmatrix out){
        out.addTextTvOut("Printing device list:");
        for(usbDevice device:this.trueList){
            out.addTextTvOut("Device "+device.getStringIdVendor()+":"+device.getStringIdProduct()+" on port  #"+device.getPort());
        }
        out.addTextTvOut("");
    }
}
